SystemOrganization addCategory: #'GSitemaps-Utils'!
SystemOrganization addCategory: #GSitemaps!

TestCase subclass: #GTestsAndExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps-Utils'!

!GTestsAndExamples methodsFor: 'examples' stamp: 'SR 12/8/2007 11:16'!
sitemap
	" this is the official example by google "
	" self new sitemap inspect "
	
	^ GSitemapDocument new version: 0.84;
		
		url: 'http://www.example.com'
		with: [:u | u  lastModification: '1/1/05' asDate;
				 changesMonthly;
				 priority: 0.8];
		
		url: 'http://www.example.com/catalog?item=12&amp;desc=vacation_hawaii'
		with: [:u | u changesWeekly];
		
		url: 'http://www.example.com/catalog?item=73&amp;desc=vacation_new_zealand'
		with: [:u | u lastModification: '12/23/04' asDate;
				 changesWeekly];
		
		url: 'http://www.example.com/catalog?item=74&amp;desc=vacation_newfoundland'
		with: [:u | u lastModification: (DateAndTime year: 2004 month: 12 day: 23 hour: 15 minute: 0) asDateAndTime asUTC;
				 changesWeekly;
				 priority: 0.3];
		
		url: 'http://www.example.com/catalog?item=83&amp;desc=vacation_usa'
		with: [:u | u lastModification: '11/11/04' asDate];
		 yourself! !

!GTestsAndExamples methodsFor: 'examples' stamp: 'SR 12/8/2007 11:16'!
sitemapindex
	" this is the official example by google "
	" self new sitemapindex inspect "
	
	^ GIndexDocument new
		sitemap: 'http://www.example.com/sitemap1.xml.gz'
			lastModification: (DateAndTime year: 2004 month: 1 day: 10 hour: 23 minute: 17);
		sitemap: 'http://www.example.com/sitemap2.xml.gz'
			lastModification: (DateAndTime year: 2005 month: 1 day: 1);
		yourself! !

!GTestsAndExamples methodsFor: 'tests' stamp: 'SR 12/8/2007 11:15'!
testWriteWithoutErrors
	self shouldnt: [ self write: self sitemap ] raise: Error.
	self shouldnt: [ self write: self sitemapindex  ] raise: Error.! !

!GTestsAndExamples methodsFor: 'private' stamp: 'SR 12/8/2007 11:15'!
write: aDocument
	^ String streamContents: [ :stream | aDocument printOn: stream ]! !

Object subclass: #GElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps-Utils'!

GElement subclass: #GDocument
	instanceVariableNames: 'schema version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps-Utils'!

!GDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:56'!
defaultVersion
	^ 0.84! !

!GDocument methodsFor: 'printing' stamp: 'SR 1/15/2008 17:30'!
printAttributesOn: aStream.
	aStream 
		space;
		nextPutAll: 'xmlns="http://www.google.com/schemas/sitemap/', self version asString, '" ';
		nextPutAll: 'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ';
		nextPutAll: 'xsi:schemaLocation="http://www.google.com/schemas/sitemap/', self version asString; space; 		nextPutAll: 'http://www.google.com/schemas/sitemap/', self version asString, '/', self schema, '.xsd"'
		! !

!GDocument methodsFor: 'printing' stamp: 'SR 12/8/2007 11:12'!
printOn: aStream
	aStream nextPutAll: '<?xml version="1.0" encoding="UTF-8"?>'; cr.
	super printOn: aStream! !

!GDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:56'!
schema
	^ schema ifNil: [ schema := self defaultSchema ]! !

!GDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:55'!
schema: anObject
	schema := anObject! !

!GDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:52'!
type
	self subclassResponsibility! !

!GDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:56'!
version
	^ version ifNil: [ version := self defaultVersion ]! !

!GDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:34'!
version: anObject
	version := anObject! !

GDocument subclass: #GIndexDocument
	instanceVariableNames: 'sitemaps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps'!

!GIndexDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:56'!
defaultSchema	
	^ 'siteindex'! !

!GIndexDocument methodsFor: 'printing' stamp: 'SR 12/8/2007 11:22'!
printContentsOn: aStream
	 self sitemaps do: [ :each | each printOn: aStream ] ! !

!GIndexDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:56'!
schema
	^ schema ifNil: [ schema := self defaultSchema ]! !

!GIndexDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:21'!
sitemap: aString
	^ self sitemap: aString lastModification: nil! !

!GIndexDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 11:00'!
sitemap: aString lastModification: aDate 
	^ self sitemaps add: ((GSitemap new)
				location: aString;
				lastModification: aDate;
				yourself)! !

!GIndexDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:17'!
sitemaps
	^ sitemaps ifNil: [ sitemaps := OrderedCollection new ]! !

!GIndexDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:52'!
type
	^ 'sitemapindex'! !

GDocument subclass: #GSitemapDocument
	instanceVariableNames: 'urls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps'!

!GSitemapDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:57'!
defaultSchema
	^ 'sitemap'! !

!GSitemapDocument methodsFor: 'printing' stamp: 'SR 12/8/2007 11:22'!
printContentsOn: aStream
	self urls do: [ :each | each printOn: aStream ]! !

!GSitemapDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:53'!
type
	^ 'urlset'! !

!GSitemapDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:26'!
url: aString
	^ self url: aString with: [ ]! !

!GSitemapDocument methodsFor: 'accessing' stamp: 'SR 12/8/2007 11:00'!
url: aString with: aBlock 
	| url |
	url := GUrl new location: aString.
	aBlock valueWithPossibleArgument: url.
	^ self urls add: url! !

!GSitemapDocument methodsFor: 'private' stamp: 'SR 12/8/2007 10:26'!
urls
	^ urls ifNil: [ urls := OrderedCollection new ]! !

!GElement methodsFor: 'private-printing' stamp: 'SR 12/8/2007 11:26'!
print: aString contents: anotherString on: aStream
	aStream nextPutAll: '<', aString.
	self printAttributesOn: aStream.
	aStream nextPutAll: '>'; cr.
	aStream nextPutAll: anotherString; cr.
	aStream nextPutAll: '</', aString, '>'; cr
	! !

!GElement methodsFor: 'private-printing' stamp: 'SR 12/8/2007 11:26'!
print: aString with: aBlock on: aStream
	aStream nextPutAll: '<', aString.
	self printAttributesOn: aStream.
	aStream nextPutAll: '>'; cr.
	aBlock value.
	aStream nextPutAll: '</', aString, '>'; cr! !

!GElement methodsFor: 'printing' stamp: 'SR 12/8/2007 11:11'!
printAttributesOn: aStream! !

!GElement methodsFor: 'printing' stamp: 'SR 12/8/2007 11:09'!
printContentsOn: aStream! !

!GElement methodsFor: 'printing' stamp: 'SR 12/8/2007 11:07'!
printOn: aStream
	self print: self type with: [ self printContentsOn: aStream ] on: aStream! !

!GElement methodsFor: 'private' stamp: 'SR 12/8/2007 11:07'!
type
	self subclassResponsibility! !

GElement subclass: #GSitemap
	instanceVariableNames: 'lastModification location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps-Utils'!

!GSitemap methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:18'!
lastModification
	^ lastModification ifNil: [ lastModification := DateAndTime today ]! !

!GSitemap methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:15'!
lastModification: anObject
	lastModification := anObject! !

!GSitemap methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:15'!
location
	^ location! !

!GSitemap methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:15'!
location: anObject
	location := anObject! !

!GSitemap methodsFor: 'printing' stamp: 'SR 12/8/2007 11:22'!
printContentsOn: aStream
	self print: #loc contents: self location asString on: aStream.
	self print: #lastmod contents: self lastModification asUTC asString on: aStream.! !

!GSitemap methodsFor: 'accessing' stamp: 'SR 12/8/2007 11:08'!
type
	^ 'sitemap'! !

GElement subclass: #GUrl
	instanceVariableNames: 'changeFrequency lastModification location priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSitemaps-Utils'!

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:13'!
changeFrequency
	^ changeFrequency ifNil: [ self changesWeekly. changeFrequency ]! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:03'!
changeFrequency: anObject
	changeFrequency := anObject! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:11'!
changesAlways 
	self changeFrequency: #always! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:12'!
changesDaily
	self changeFrequency: #daily! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:12'!
changesHourly
	self changeFrequency: #hourly! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:12'!
changesMonthly
	self changeFrequency: #monthly! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:12'!
changesNever
	self changeFrequency: #never! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:12'!
changesWeekly
	self changeFrequency: #weekly! !

!GUrl methodsFor: 'accessing-convenience' stamp: 'SR 12/8/2007 10:12'!
changesYearly
	self changeFrequency: #yearly! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:13'!
lastModification
	^ lastModification ifNil: [ lastModification := DateAndTime today ]! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:03'!
lastModification: anObject
	lastModification := anObject! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:03'!
location
	^ location! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:04'!
location: anObject
	location := anObject! !

!GUrl methodsFor: 'printing' stamp: 'SR 12/8/2007 11:44'!
printContentsOn: aStream
	self print: #loc contents: self location asString on: aStream.
	self print: #lastmod contents: self lastModification asDateAndTime asUTCString asString on: aStream.
	self print: #changefreq contents: self changeFrequency asString on: aStream.
	self print: #priority contents: self priority asString on: aStream.! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:13'!
priority
	^ priority ifNil: [ priority := 0.75 ]! !

!GUrl methodsFor: 'accessing' stamp: 'SR 12/8/2007 10:03'!
priority: anObject
	priority := anObject! !

!GUrl methodsFor: 'private' stamp: 'SR 12/8/2007 11:08'!
type
	^ 'url'! !

!DateAndTime methodsFor: '*GSitemaps' stamp: 'SR 12/8/2007 11:45'!
asUTCString
	" unfortunately utc implementation varies from each squeak version ;( - this is just a quick hack "
	^ String streamContents: [ :stream | stream 
		nextPutAll: self year asString; nextPut: $-;
		nextPutAll: self month asString; nextPut: $-;
		nextPutAll: self daysInMonth asString; nextPut: $T;
		nextPutAll: (self hours abs asString padded: #left to: 2 with: $0); nextPut: $:;
		nextPutAll: (self minutes abs asString padded: #left to: 2 with: $0); nextPut: $:;
		nextPutAll: (self seconds abs asString padded: #left to: 2 with: $0); nextPut: (self offset positive ifTrue: [ $+ ] ifFalse: [ $- ]);
		nextPutAll: (self offset hours abs asString padded: #left to: 2 with: $0); nextPut: $:;
		nextPutAll: (self offset minutes abs asString padded: #left to: 2 with: $0) ]! !
